#!/bin/sh
#
# SlackPackager v. 0.2
#
# Copyright (c) 2003, Simone Bianchini, http://web.tiscali.it/gnu.linux.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Un ringraziamento particolare a Luigi A. Bassetti...per avermi spronato!
#
# SlackPackager permette di creare in modo del tutto automatico paccheti .tgz per Slackware
# a partire dai sorgenti in formato [nome pacchetto]-[versione].tar.gz o tar.bz2
# Lo script richiede all'utente solo l'inserimento del nome pacchetto, della versione, del
# formato dei tarball e dell'architettura su cui intende compilare i sorgenti per ottenere una
# compilazione ottimizzata attraverso l'uso delle CFLAGS di ottimizzazione del compilatore.
# Gli eseguibili ottenuti vengono infine "strippati" ovvero snelliti per ottenere applicazioni
# pi leggere. Lo script deve essere lanciato nella directory dove si trovano i sorgenti che
# si intende utilizzare e provveder al termine di tutte le operazioni a spostare il pacchetto
# nella directory di lavoro stessa. Provveder anche ad eliminare tutto ci che di
# superfluo lo script e la compilazione hanno prodotto.         -- Have fun!!
#
# Questa versione ha una GUI costruita sul tool "dialog" presente in Slackware.
#
# Bisogna essere root
if [ "${UID}" != 0 ] ; then
  dialog --title "SlackPackager" --msgbox "Bisogna essere root per avviare questo script" 10 35
  exit 1
fi
dialog --title "SlackPackager" --msgbox "

=====================================================

 +++++  Slack-Packager v. 0.2 --velenux coded  +++++

=====================================================

Copyright (c) 2003, Simone Bianchini, http://web.tiscali.it/gnu.linux.

Potrai creare pacchetti Slackware (.tgz) a partire dai sorgenti dell'applicazione con ottimizzazioni nella compilazione per architetture i386 e i486" 20 60
POS=`pwd`
if [ "$TMP" = "" ] ; then
  TMP=/tmp;
fi
mkdir -p $TMP/package
PKG=$TMP/package
dialog --title "SlackPackager v.0.2" --msgbox "
++++=============================================++++
 Puoi creare un pacchetto .tgz scegliendo tra questi
 tarball dei sorgenti:
=====================================================
`ls *tar.gz *tar.bz2`" 20 60
dialog --title "SlackPackager v.0.2" --inputbox "
++++=============================================++++
Inserisci il NOME del programma come visualizzato
nel tarball scelto escludendo la versione indicata:
=====================================================
`ls *tar.gz *tar.bz2`" 20 60 2> /tmp/nome
dialog --title "SlackPackager v.0.2" --inputbox "
++++=============================================++++
      Inserisci la VERSIONE del programma:
=====================================================
`ls *tar.gz *tar.bz2`" 20 60 2> /tmp/versione
dialog --title "SlackPackager v.0.2" --inputbox "
++++=============================================++++
      Inserisci l'ARCHITETTURA di riferimento:
      i386 o i486
=====================================================" 20 60 2> /tmp/architettura
dialog --title "SlackPackager v.0.2" --inputbox "
++++=============================================++++
   Inserisci il FORMATO del tarball dei sorgenti:
   tar.gz o tar.bz2
=====================================================" 20 60 2> /tmp/formato
NAME=`cat /tmp/nome`
VERSION=`cat /tmp/versione`
ARCH=`cat /tmp/architettura`
BUILD=1
FORMAT=`cat /tmp/formato`
dialog --title "SlackPackager v.0.2" --inputbox "
++++=============================================++++
   Devi scegliere il PATH per l'installazione tra:
   /usr e /usr/local
=====================================================" 20 60 2> /tmp/scelta
SCELTA=`cat /tmp/scelta`
dialog --title "SlackPackager v.0.2" --infobox "
++++=============================================++++
      La compilazione  in corso...attendere

                   Have fun!! :-P
===================================================" 10 60 ; sleep 4
mkdir $PKG/$SCELTA
PERCORSO=$PKG/$SCELTA
mkdir -p $PERCORSO/doc/$NAME-$VERSION
if [ $FORMAT = tar.gz ] ; then
    tar xvzf $POS/$NAME-$VERSION.$FORMAT;
elif [ $FORMAT = tar.bz2 ] ; then
    tar xvfj $POS/$NAME-$VERSION.$FORMAT;
fi
cd $NAME-$VERSION
CFLAGS="-O2 -march=$ARCH -mcpu=i686" ./configure --prefix=/usr
make && make prefix=$PERCORSO install && make clean
cp -a AUTHORS INSTALL README ChangeLog $PERCORSO/doc/$NAME-$VERSION
strip $PERCORSO/bin/*
chown -R root.bin $PERCORSO/bin
chmod 644 $PERCORSO/doc/$NAME-$VERSION/*
chown -R root.root $PERCORSO/doc/$NAME-$VERSION
chown -R root.root $PERCORSO/share
mkdir -p $PKG/install
dialog --title "SlackPackager v.0.2" --msgbox "
++++=============================================++++
      Inserisci una descrizione del pacchetto
=====================================================
The Handy Ruler below makes it easier to edit a package description. Line up the first '|' above the ':' following the base package name, and the '|' on the right side marks the last column you can put a character in. You must make exactly 11 lines for the formatting to be correct. It's also customary to leave one space after the ':'." 20 60
dialog --title "SlackPackager v.0.2" --inputbox "Inserisci una descrizione del pacchetto rispettando la formattazione definita dall'Handy Ruler e inserendo un max di 11 righe:

|-----handy-ruler------------------------------------------------------|" 20 85 2> /tmp/desc
DESC=`cat /tmp/desc`
echo "$NAME: $DESC" > $POS/slack-desc
echo "$NAME: " >> $POS/slack-desc
dialog --title "SlackPackager" --inputbox "Continua con un'altra riga di descrizione rispettando sempre la formattazione definita dall'Handy Ruler:

|-----handy-ruler------------------------------------------------------|" 20 85 2> /tmp/desc1
DESC1=`cat /tmp/desc1`
echo "$NAME: $DESC1" >> $POS/slack-desc
echo "$NAME: " >> $POS/slack-desc
if [ -e $POS/slack-desc ] ; then
  cat $POS/slack-desc > $PKG/install/slack-desc;
fi
if [ -e $POS/doinst.sh ] ; then
  cat $POS/doinst.sh > $PKG/install/doinst.sh;
fi
cd $PKG
makepkg -l y -c n $TMP/$NAME-$VERSION-$ARCH-$BUILD.tgz
dialog --title "SlackPackager v.0.2" --infobox "
++++=============================================++++
     Il Pacchetto $NAME-$VERSION-$ARCH-$BUILD.tgz
              stato correttamente creato

              The Slack-it Linux project
            http://web.tiscali.it/gnu.linux
                    --velenux :-P
=====================================================" 20 60 ; sleep 3
mv $TMP/$NAME-$VERSION-$ARCH-$BUILD.tgz $POS
rm -rf $PKG
rm -rf $POS/slack-desc
rm -rf $POS/$NAME-$VERSION
cd $TMP
rm -rf architettura desc desc1 formato nome scelta versione
exit 0